import jp.jig.jiglet.*;

public class Weather extends Jiglet {
	String[] prefList = {
		"Sen̂VC", "kC(k)", "kC()", "kC()", "kC()", "X", "Hc", "", "{", "R`", "", "", "Ȗ", "Qn", "", "s", "t", "_ސ", "R", "", "V", "xR", "ΐ", "", "É", "m", "", "Od", "", "s{", "{", "", "ޗ", "a̎R", "R", "L", "", "", "R", "", "", "Q", "m", "", "啪", "", "", "F{", "{", "", "",
	};
	String[] urlList = new String[] {
		"", "hokkaido-douhoku", "hokkaido-doutou", "hokkaido-douou", "hokkaido-dounan", "aomori", "akita", "iwate", "miyagi", "yamagata",
		"fukushima", "ibaragi", "tochigi", "gunma", "saitama", "tokyo", "chiba", "kanagawa", "yamanashi", "nagano",
		"niigata", "toyama", "ishikawa", "fukui", "shizuoka", "aichi", "gifu", "mie", "shiga", "kyoto",
		"osaka", "hyogo", "nara", "wakayama", "okayama", "hiroshima", "shimane", "tottori", "yamaguchi", "tokushima",
		"kagawa", "ehime", "kochi", "fukuoka", "oita", "nagasaki", "saga", "kumamoto", "miyazaki", "kagoshima", "okinawa",
	};
	
	int cursor = -1;
	int offset;
	int fontH = 0;
	int row = 12;
	int bx = 0;
	int by = 0;
	int bw = 0;
	int bh = 0;
	
	public void main() {
		setSoftLabel("I");
		//XNb`pbhOʒuǂݍ
		byte[] sp = readSP(0, 2);
		cursor = (sp[0] & 0xFF);
		offset = (sp[1] & 0xFF);
		
		//C[v
		clearKey();
		long time = currentTime();
		int key = 0;
		for (;;) {
			if (key >= 0) {
				if (offset > cursor - 1) {
					offset = cursor - 1;
				}
				if (offset <= cursor - row + 1) {
					offset = cursor - row + 2;
				}
				if (offset > prefList.length - row) {
					offset = prefList.length - row;
				}
				if (offset < 0) {
					offset = 0;
				}
			}
			
			repaint();
			int def = (int)(currentTime() - time);
			sleep(50 - def);
			time = currentTime();
			
			do {
				key = getKey();
			} while (key < 0);
			
			if (key == KEY_UP) {
				cursor = (cursor - 1 + prefList.length) % prefList.length;
			}
			if (key == KEY_DOWN) {
				cursor = (cursor + 1) % prefList.length;
			}
			if (key == KEY_SELECT) {
				String url = "http://www.e-tenki.net/";
				if (cursor > 0) {
					url += "wr/" + urlList[cursor] + ".html";
				}
				sp[0] = (byte)cursor;
				sp[1] = (byte)offset;
				writeSP(0, sp);
				
				launch(url, ENCODE_EUC, LAUNCH_TERMINATE);
			}
			if (key == KEY_SOFT || key == KEY_IAPP) {
				terminate();
			}
		}
	}
	
	//`揈
	public void paint(boolean allDrawFlag) {
		if (cursor < 0) {
			return;
		}
		setFont(0);
		if (fontH == 0) {
			//ϐ
			fontH = getFontHeight();
			
			bw = (fontH * 8) + 12;
			bh = (fontH + 2) * row + 12;
			bx = (DW - bw) / 2;
			by = (DH - bh) / 2;
		}
		//Xg`
		draw3DButton(bx, by, bw, bh);
		int x = bx + 3;
		int y = by + 3;
		draw3DRect(x, y, bw - 6, bh - 6);
		x += 3;
		y += 3;
		
		for (int i = offset; i < offset + row; i++) {
			if (i == cursor) {
				setColor(getSystemColor(SYSTEM_COLOR_MENU_CURSOR));
				fillRect(x - 1, y, bw - 11, fontH + 1);
				setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT2));
			} else {
				setColor(getSystemColor(SYSTEM_COLOR_MENU_FONT1));
			}
			drawString(prefList[i], x, y + fontH);
			y += fontH + 2;
		}
		//XN[o[`
		int barX = bx + bw - 5;
		int barH = bh - 6 + 1;
		setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BG));
		fillRect(barX, by + 3, 3, barH);
		
		int barY = offset * barH / prefList.length;
		barH = row * barH / prefList.length;
		setColor(getSystemColor(SYSTEM_COLOR_SCROLL_BAR));
		fillRect(barX, by + 3 + barY, 3, barH);
	}
}
